#include "X3D_Sphere.h"

namespace X3DTK {
namespace X3D {

Sphere::Sphere()
: X3DGeometry3DNode(), _radius(1.0f)
{
  defineTypeName("Sphere", "Geometry3D");
}

Sphere::Sphere(const SFFloat &radius)
: X3DGeometry3DNode(), _radius(radius)
{
  defineTypeName("Sphere", "Geometry3D");
}

Sphere::Sphere(const Sphere &C) 
: X3DGeometry3DNode(C), _radius(C._radius)
{
}

SFAbstractNode Sphere::clone() const
{
  return new Sphere(*this);
}

Sphere::~Sphere()
{
}

void Sphere::setRadius(const SFFloat &radius)
{
  _radius = radius;
}

void Sphere::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("radius");
  if (index != -1)
    _radius = element->getAttribute(index).toFloat();
}

SFString &Sphere::write(SFString &output) const
{
  if (_radius != 1.0f)
    output += " radius=\"" + toSFString(_radius) + "\"";
  
  return output;
}

}
}

