#include "X3D_Shape.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

Shape::Shape()
: X3DShapeNode(), X3DBoundedObject()
{ 
  defineTypeName("Shape", "Shape");
}

Shape::Shape(X3DGeometryNode *geometry, X3DAppearanceNode *appearance,  const SFVec3f &bboxCenter,  const SFVec3f &bboxSize)
: X3DShapeNode(geometry, appearance), X3DBoundedObject(bboxCenter, bboxSize)
{
  defineTypeName("Shape", "Shape");
}

Shape::Shape(const Shape &S)
: X3DShapeNode(S), X3DBoundedObject(S)
{
}

SFAbstractNode Shape::clone() const
{
  return new Shape(*this);
}

Shape::~Shape()
{
}

void Shape::load(const X3DFileElement *element)
{
  X3DBoundedObject::load(element);
}

SFString &Shape::write(SFString &output) const
{
  return X3DBoundedObject::write(output);
}

}
}
