#include "ClonerAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

ClonerAbstractVisitor::ClonerAbstractVisitor()
{
  stateVariables = GraphTraversal::getInstanceOf<ClonerStateVariables>();
  
  defineEnterFunction(&ClonerAbstractVisitor::enterX3DAbstractNode);
  defineLeaveFunction(&ClonerAbstractVisitor::leaveX3DAbstractNode);
}

ClonerAbstractVisitor::~ClonerAbstractVisitor()
{
}

void ClonerAbstractVisitor::enterX3DAbstractNode(X3DAbstractNode *N) const
{
  SFAbstractNode NN = stateVariables->getNode(N);
  if (NN == 0)
  {
    NN = N->clone();
    
    stateVariables->addCoupleNode(N, NN);
    // removing children.
    MFAbstractNode childrenList = NN->getChildrenList();
    for (MFAbstractNode::const_iterator it = childrenList.begin(); it != childrenList.end(); ++it)
      NN->removeChild(*it);
  }
    
  stateVariables->pushNode(NN);
}

void ClonerAbstractVisitor::leaveX3DAbstractNode(X3DAbstractNode *) const
{
  stateVariables->popNode();
}

}
