#include "GraphTester.h"
#include "X3DAbstractNode.h"
#include "X3D_DFSGraphTraversal.h"
#include "GL_DFSGraphTraversal.h"
#include "MESH_DFSGraphTraversal.h"
#include "GraphTesterAbstractVisitor.h"

namespace X3DTK {

GraphTester::GraphTester()
{
  stateVariables = GraphTraversal::getInstanceOf<GraphTesterStateVariables>();
  
  graphTraversal = mergeGraphTraversals(new X3D::DFSGraphTraversal(), new GL::DFSGraphTraversal());
  graphTraversal = mergeGraphTraversals(graphTraversal, new MESH::DFSGraphTraversal());
  
  graphTraversal->setComponentVisitor(new GraphTesterAbstractVisitor());
}

GraphTester::~GraphTester()
{
  GraphTraversal::removeInstanceOf<GraphTesterStateVariables>();
  
  delete graphTraversal;
}
  
void GraphTester::test(SFAbstractNode N) const
{
  stateVariables->init();
  graphTraversal->traverse(N);
}
  
}
